## Script (Python) "blogTool"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
"""
This script handles finding blog entries in the catalog and creatintg a formated calendar for navigation
It needs work but does evertyhing I need it to right now.
version = 0.5
Licensed under the ZPL, please send any changes to natesain@yahoo.com
"""
try:  # here we do calendar stuff
   import calendar
   calendar.setfirstweekday(6) # set cal to display sun first
   fday = calendar.firstweekday()
except: # no calendar modules so we need to do some substatution
   calendar = container # calendar functions should be scripts in the same container as this one
   fday = 6 # manualy set first day. make sure your scripts assume this or make a new script to handle setting the fday
import string
request = context.REQUEST
response = request.RESPONSE
catalog = context.portal_catalog # set default catalog
mypath = context.absolute_url(relative=1) # the path the script is called from
t_s = traverse_subpath #this saves a lot of typing!

def mkdateString(t_s=traverse_subpath):
    """Trying and see if a date is in the URL"""
    dayURL = None
    if len(t_s) == 3 and len(t_s[0]) == 4: # get numerical date (year/month/day) we need to check for numbers only with re
        if len(t_s[1]) == 1: t_s[1] = '0'+t_s[1]
        if len(t_s[2]) == 1: t_s[2] = '0'+t_s[2]
        get_date = '%s-%s-%s 00:00:00' % tuple(t_s)
        dayURL = 1 # when this is set display only blogs for set day
    elif len(t_s) == 2 and len(t_s[0]) == 4: #get numerical date (year/month) add day as last day of month
        yearNo,monthNo = string.atoi(t_s[0]),string.atoi(t_s[1])
        dayNo = calendar.monthrange(yearNo,monthNo)[1]
        get_date = '%s-%s-%s 00:00:00' % (yearNo,monthNo,1)
    else:
        get_date = DateTime().ISO()
    return get_date,dayURL

def dictToCSS(css_dict,css=''):
    for item in css_dict.items(): css += '%s{%s}\n' % item
    return css

def dictToAttribs(attrib_dict,attribs=''):
    if not same_type(attrib_dict,{}): return '' 
    for item in attrib_dict.items(): 
        if len(item[0]) and len(item[1]):
            attribs += '%s="%s" ' % item
    if len(attribs): return attribs
    return ''

def cal_header(kwargs={}):
    header_fmt = {'dayattribs':{'class':'daynames','style':''},'daytag':'th',
                  'monthattribs':{'class':'monthname',},'monthtag':'caption',
                  'daycondition':None,'monthcondition':None} 
    header_fmt.update(kwargs)  
    day_names = 'Mon','Tue','Wed','Thu','Fri','Sat','Sun'
    day_fmt = {'template':'<%(tag)s %(attribs)s >%(dayname)s</%(tag)s>',
               'attribs':header_fmt['dayattribs'],'tag':header_fmt['daytag']}
    month_fmt = {'template':'<%(tag)s %(attribs)s>%(monthname)s</%(tag)s>',
                 'monthname':Month,'attribs':header_fmt['monthattribs'],
                 'tag':header_fmt['monthtag']}
    if fday: day_names = day_names[fday:]+day_names[:fday] # reorder the days for the header
    if header_fmt['monthcondition']: month_fmt = header_fmt['monthcondition'](month_fmt)
    month_fmt['attribs'] = dictToAttribs(month_fmt['attribs'])
    month_header = month_fmt['template'] % month_fmt
    days_header = ''
    for day in day_names:
        day_fmt['dayname'],day_fmt['attribs']  = day,header_fmt['dayattribs']
        if header_fmt['daycondition']: day_fmt = header_fmt['daycondition'](day_fmt)
        day_fmt['attribs'] = dictToAttribs(day_fmt['attribs'])
        days_header += day_fmt['template'] % day_fmt
    return month_header,days_header


def cal_body(**kwargs):
    body_fmt = {'dayattribs':{'class':'day'},
                'nondayattribs':{'class':'day','style':'visibility: hidden;'},
                'daytag':'td','weektag':'tr',
                'weekattribs':{'weekclass':'','weekstyle':''},
                'daycondition':None,'weekcondition':None}
    body_fmt.update(kwargs)
    month_data = calendar.monthcalendar(year,month)
    
    days = []
    day_fmt = {'template':'<%(tag)s %(attribs)s>%(day)s</%(tag)s>'}
    week_fmt = {'template':'<%(tag)s %(attribs)s >%(days)s</%(tag)s>\n'}

    for week in month_data:
        row = ''
        week_fmt['tag'] = body_fmt['weektag']
        week_fmt['attribs'] = body_fmt['weekattribs']
        if body_fmt['weekcondition']: week_fmt = body_fmt['weekcondition'](week_fmt)
        week_fmt['attribs'] = dictToAttribs(week_fmt['attribs'])
        for day in week: #first we set a dict for format of the day
            day_fmt['attribs']=body_fmt['dayattribs']  # calendar days
            if not day: day = '&nbsp;'
            day_fmt['tag'],day_fmt['day'] = body_fmt['daytag'],day
            if body_fmt['daycondition']: day_fmt = body_fmt['daycondition'](day_fmt) # condition allows changing day_fmt
            day_fmt['attribs'] = dictToAttribs(day_fmt['attribs'])
            row += day_fmt['template'] % day_fmt
        if body_fmt['weektag']:
            week_fmt['days'] = row 
            row = week_fmt['template'] % week_fmt
        days.append(row)

    return string.join(days)

def mkcal():
    #header_css = "<div class='cal'>" + cal_header(htmltag='div')
    #body_css = cal_body(daytag='div',weektag=None,daycondition=istoday) + "</div>"
    header = '<table id="calendar" border="0" cellspacing="0" cellpadding="2" summary="Monthly calendar with links to each days posts"> \n \
              %s \n  <thead><tr> %s </tr></thead>\n' % cal_header()
    body = "<tbody>\n%s\n</tbody>\n</table>\n" % cal_body(daycondition=isBlogDay) 
    cal = header + body
    return cal

def callinks(month,year): 
    """returs a dictionary with strings that can be uses as relative urls to navigate forward and backward a month
    expects input as ints: year and month
    """
    lm_nm = test(month > 1 and month < 12,(month-1,year,month+1,year),test(month==1,(12,year-1,month+1,year),(month-1,year,1,year+1)))
    nmDO = None # we man not need this
    lmDO = mDO - ((day-1) + calendar.monthrange(lm_nm[1],lm_nm[0])[1])
    if not todayDO.month() == mDO.month(): nmDO = mDO + ((calendar.monthrange(year,month)[1] - (day)) + calendar.monthrange(lm_nm[3],lm_nm[2])[1])
    lmData = {'rURL':'%s/%s' % (lm_nm[1],lm_nm[0]),'name':lmDO.Month(),'day':lmDO.day(),'year':lmDO.year()}
    if nmDO: nmData = {'rURL':'%s/%s' % (lm_nm[3],lm_nm[2]),'name':nmDO.Month(),'day':nmDO.day(),'year':nmDO.year()}
    else: nmData = None
    return {'lmData':lmData,'nmData':nmData}


    

def istoday(item_fmt):
    """ a  filter that makes the background of a day gray"""
    DTtoday = DateTime()
    if DTtoday.month() == month and DTtoday.year() == year and DTtoday.day() == item_fmt['day']:
       item_fmt['day'] = '<a href="index.html">%s</a>' % item_fmt['day']
       if item_fmt['attribs'].has_key('style'): 
           item_fmt['attribs']['style'] = item_fmt['attribs']['style'] + 'background-color: #ccc;'
       else: item_fmt['attribs']['style'] = 'background-color: #ccc;'
    return item_fmt
    
def isBlogDay(item_fmt):
    """ a filter that creates a link for each day that has a blog """
    for blog in monthBlogs:
        if blog.created.day() == item_fmt['day'] and blog.created.month() == month:
            blogURL = "%s/%s/%s" %(blog.created.year(),blog.created.month(),blog.created.day())
            item_fmt['day'] = '<a href="%s">%s</a>' % (blogURL,item_fmt['day'])
    return item_fmt

def blogDaySearch(DateObject):
    """do blog serach: is in date range, is in my path, does it have a subject blog"""  
    blogs = catalog(created={'query':[DateObject.earliestTime(),DateObject.latestTime()],'range':'minmax'},
                   #path={'query':'/'+mypath,'level':0},
                   Type={'query':'Blog Entry'},sort_on='created',sort_order='reverse') 
    return blogs

def blogSearch(DateObject,maxBlogs=10):
    blogs = catalog(created={'query':DateObject,'range':'max'},
                   #path={'query':'/'+mypath,'level':0},
                   Type={'query':'Blog Entry'},
                   sort_on='created',sort_order='reverse')
    return blogs

def blogMonthSearch():
    mrange = calendar.monthrange(year,month)
    if mrange[0] < 1: mrange = (1,mrange[1])
    firstDay = DateTime('%s-%s-%s 00:00:00' % (year,month,mrange[0]))
    blogs = catalog(created={'query':[firstDay,firstDay + mrange[1]],'range':'minmax'},
                   #path={'query':'/'+mypath,'level':0},
                   Type={'query':'Blog Entry'}) 
    return blogs


   

myDate,dayURL = mkdateString() # parse the date from the url
mDO = DateTime(myDate).latestTime()  # create a date object
todayDO = DateTime()  # create a date object for today
if mDO.day() == todayDO.day(): mDO = todayDO  # if its today set the time to now
#set up global vars
month = mDO.month()
Month = mDO.Month() 
year = mDO.year()
day = mDO.day()
monthBlogs = blogSearch(todayDO) 
if dayURL:
    blogs = blogDaySearch(mDO)
else:
    blogs = monthBlogs
mycal = mkcal() #make calendar
clinks = callinks(month,year)  # calendar nav links
return {'calendar':mycal,'blogs':blogs,'clinks':clinks}
