from Products.CMFCore.TypesTool import FactoryTypeInformation as FTI
from Products.CMFCore.utils import getToolByName

def install(self):
    """ installs the CMFWeblog """
    typesTool=getToolByName(self, 'portal_types')
    memberdataTool=getToolByName(self, 'portal_memberdata')
    skinsTool=getToolByName(self, 'portal_skins')
    if 'Blog Entry' not in typesTool.objectIds():
        try:
            typesTool.manage_addTypeInformation(id='Blog Entry', typeinfo_name='CMFDefault: Document')
        except:
            typesTool.manage_addTypeInformation(FTI.meta_type, id='Blog Entry', typeinfo_name='CMFDefault: Document')
        blogType=typesTool.getTypeInfo('Blog Entry')
        blogType.manage_changeProperties(content_meta_type='Blog Entry')
    if not memberdataTool.hasProperty('blogLocations'):
        memberdataTool.manage_addProperty(id='blogLocations',value='Home',type='lines')
    
    #add the CMFWeblog Tool
    portal=getToolByName(self, 'portal_url').getPortalObject()
    portal.manage_addProduct['CMFWeblog'].manage_addTool(type='CMF Weblog Tool')

    #register CMFWeblog as a ActionProvider
    getToolByName(self,'portal_actions').addActionProvider('portal_weblog')
		    
    return 'CMF WeblogTool succesfully installed'
